window.GetElementHeight = function (id) {
  const element = document.getElementById(id);

  if (!element)
  {
    return 0;
  }

  return element.getBoundingClientRect().height;
}

window.GetGridRowAvgHeight = function (id)
{
  const gridElement = document.getElementById(id);
  if (!gridElement)
  {
    return 0;
  }

  const rows = [...gridElement.getElementsByClassName("k-master-row")];

  if (rows.length <= 0)
  {
    return -1;
  }

  return rows.reduce((acc, row) => acc + row.getBoundingClientRect().height, 0) / rows.length;
}

window.GetGridContainerHeight = function (id)
{
  const gridElement = document.getElementById(id);
  if (!gridElement)
  {
    return 0;
  }

  const items = [...gridElement.getElementsByClassName("k-grid-container")];

  if (items.length <= 0)
  {
    return -1;
  }

  return items[0].getBoundingClientRect().height;
}

window.GetGridPagerHeight = function (id) {
  const gridElement = document.getElementById(id);
  if (!gridElement)
  {
    return 0;
  }

  const items = [...gridElement.getElementsByClassName("k-grid-pager")];

  if (items.length <= 0)
  {
    return -1;
  }

  return items[0].getBoundingClientRect().height;
}

window.CalculateGridPageSize = function (id) {
  let freeSpace = window.GetGridContainerHeight(id)- window.GetGridPagerHeight(id);
  let rowAvgHeight = window.GetGridRowAvgHeight(id);
  
  if (freeSpace <= 0 || rowAvgHeight < 1) {
    return 0;
  }
  
  return Math.floor(freeSpace / rowAvgHeight);
}

window.ScrollIntoView = function (id) {
  const element = document.getElementById(id);

  if (!element)
  {
    return 0;
  }
  
  element.scrollIntoView();
}

window.TriggerFileDownload = function (fileName, url) {
  const anchorElement = document.createElement('a');
  anchorElement.href = url;
  anchorElement.download = fileName ?? '';
  anchorElement.click();
  anchorElement.remove();
}

window.SpellcheckOff = function () {
  document.querySelectorAll('input, textarea').forEach(field => field.spellcheck = false)
}